/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
//#include <stdio.h> //sprintf



//===========================================
// Global variables
//===========================================


//===========================================
// Function prototypes
//===========================================
void Print64(int64_t value);                 
char* itoa10(int64_t value, char* result);  



void Initialize(void)
{
    CyGlobalIntEnable;  
        
    UART_1_Start();
    CyDelay(1000);           // waiting for clear start after power on
    UART_1_PutString("Printing 64-bit integer without sformat()\r\n");  
}

int main(void)
{
 
    Initialize();

    int64_t i64;

    i64 = 0;            Print64(i64);
    i64 = INT8_MAX;     Print64(i64);
    i64 = INT8_MIN;     Print64(i64);
    i64 = INT16_MAX;    Print64(i64);
    i64 = INT16_MIN;    Print64(i64);
    i64 = INT32_MAX;    Print64(i64);
    i64 = INT32_MIN;    Print64(i64);
    i64 = INT64_MAX;    Print64(i64);
    i64 = INT64_MIN;    Print64(i64);

    for(;;){}
    
}


//==============================================================================
// Print value 
//==============================================================================

void Print64(int64_t val) // convert temperature code to deg C and send to BlueTooth
{
    char buf[20];   // buffer
      
    //itoa10(val, buf);      // useful for formatting   
    //UART_1_PutString(buf); //ok

    UART_1_PutString(itoa10(val, buf)); //ok
    UART_1_PutCRLF(0);
}


//==============================================================================
// C++ version 0.4 char* style "itoa":
// Written by Lukás Chmela
// Released under GPLv3.
// http://www.jb.man.ac.uk/~slowe/cpp/itoa.html
// here: modified for radix 10 only 
//==============================================================================

//char* itoa10(int value, char* result)
char* itoa10(int64_t value, char* result)
{
    const uint8 base = 10u;
	char* ptr = result, *ptr1 = result, tmp_char;
	int tmp_value;
	
	do {
		tmp_value = value;
		value /= base;
		*ptr++ = "9876543210123456789" [9 + tmp_value - value * base];
	} while ( value );
	
	// Apply negative sign
	if (tmp_value < 0) *ptr++ = '-';
	*ptr-- = '\0';
	while(ptr1 < ptr) {
		tmp_char = *ptr;
		*ptr--= *ptr1;
		*ptr1++ = tmp_char;
	}
	return result;
}




/* [] END OF FILE */
